#!/usr/bin/perl -w
my $cottage=0;
my $player=1;
my $ogre=2;

my ($mushhroom,$key,$cake,$ogreAlive);
&startGame();

sub startGame
{
   $mushroom  = $cottage;
   $key       = $ogre;
   $cake      = $cottage;
   $ogreAlive = 1;
   &outsideCottage();
}

sub outsideCottage
{
   print "You are outside a cottage\n";
   print "Birds are tweeting and in the distance, you think you can hear the\n";
   print "mooing of a cow.\n";
   print "You can go around or inside the cottage\n";
   print ">";
   
   my $response = <STDIN>;
   chomp ($response);
   
   if ($response eq "Go around cottage")
   {
      &meetOgre();
         }
   elsif ($response eq "Go inside cottage")
   {
      &insideCottage();
   }
   else
   {
      print "I beg your pardon?\n";
      &outsideCottage();
   }
}

sub meetOgre
{
   print "You are in a back garden. Lots of things have decayed\n";
   if ($ogreAlive)
   {
      print "including the teeth of a sleeping ogre.Every snore seems to shake",
      "you off your feet\n",
      "In the ogre's lap, there is a key with a strange lock shape.\n",
      "Whatever could that be for?\n";
   }
   else
   {
      print "There is a dead ogre lying behind an upturned ten-legged stool.\n"
   }
   print "You can:\n",
   "Go to front of cottage\n";
   if ($ogreAlive)
   {
      print "Wake the ogre\n";
      if ($key eq $ogre)
      {
         print "Take the Key\n";
      }
      if ($mushroom eq $player)
      {
         print "Put mushroom in ogre's mouth\n";
      }
   }
   print ">";
   
   my $response = <STDIN>;
   chomp ($response);
   
   if ($response eq "Wake the ogre" or $response eq "Take the Key")
   {
      print "The ogre wakes up.\n",
      "It peers round carefully.\n",
      "It mutters 'Ah, There you are'.\n",
      "It bashes you over the head and kills you.\n";

       &askRestart();
   }
   elsif ($response eq "Put mushroom in ogre's mouth")
   {
      if ($mushroom eq $player)
      {
         if ($cake eq $player)
     {
            print "You wedge the mushroom in the ogre's decaying jaws.\n",
        "He falls to the ground, dead.\n",
        "The key slips from his lap and lands in your pocket with a bump.\n";
        $key = $player;
        $ogreAlive = 0;
     }
     else
     {
        print "You are too scared\n";
     }
      }
      else
      {
         print "You don't have a mushroom, cheat!\n";
      }
      &meetOgre();
   }
   elsif ($response eq "Go to front of cottage")
   {
      &outsideCottage();
   }
   else
   {
      print "I beg your pardon?\n";
      &meetOgre();
   }
}

sub insideCottage
{
   print "You are in some sort of workroom in a cottage. The room is made of\n",
   "Oak Wood. There is a strong table with a chest underneath it\n",
   "There is:";
   if ($cake eq $cottage)
   {
      print "a cake";
      if ($mushroom eq $cottage)
      {
         print " and ";
      }
   }
   if ($mushroom eq $cottage)
   {
      print "a mushroom";
   }
   elsif ($cake ne $cottage)
   {
      print "nothing";
   }
   print " on the table. Each lock has a different keyhole and all the \n",
   "doors are locked except the door out. You can\n",
   "Leave the cottage\n";
   if ($cake eq $cottage)
   {
      print "Eat the cake\n";
   }
   if ($mushroom eq $cottage)
   {
      print "Eat the mushroom\n";
      print "Take the mushroom\n";
   }
   if ($key eq $player)
   {
      print "Open the chest\n";
   }
   print ">";
   
   my $response = <STDIN>;
   chomp($response);
   
   if ($response eq "Leave the cottage")
   {
      &outsideCottage();
   }
   elsif ($response eq "Eat the cake")
   {
      if ($cake eq $cottage)
      {
         print "You feel much stronger and braver\n";
     $cake = $player;
      }
      else
      {
         print "Greedy! There's only the one cake, the one you've eaten!\n";
      }
      
      &insideCottage()
   }
   elsif ($response eq "Eat the mushroom")
   {
      print "Did your parents or teachers ever tell you not to eat\n",
      "unidentified mushrooms? You drop to the floor, dead.\n";
      &askRestart();
   }
   elsif ($response eq "Take the mushroom")
   {
      if ($mushroom eq $cottage)
      {
         $mushroom = $player;
     print "You slip the mushroom inside your pocket\n";
      }
      else
      {
         print "Where is the mushroom?\n";
      }
      &insideCottage();
   }
   elsif ($response eq "Open the chest")
   {
      if ($key eq $player)
      {
         print "You have found a ton of treasure! Well done!\n";
     &askRestart();
      }
      else
      {
         print "A sudden ticking starts up, then, a jack-in-the-box springs\n",
     "up and punches you on the nose!";
     &insideCottage();
      }
   }
   else
   {
      print "I beg your pardon?\n";
      &insideCottage();
   }
}

sub askRestart
{
   print "Do you want to start again?\n>";
      
   my $response = <STDIN>;
   chomp ($response);
      
   if ($response eq "yes")
   {
      &startGame();
   }
}

1;
